//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAppMainForm* AppMainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action11Execute(TObject* ASender)
{
	DocumentCommands->Scan();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action11Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanScan();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action12Execute(TObject* ASender)
{
	DocumentCommands->ShowOptions();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action12Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanShowOptions();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action13Execute(TObject* ASender)
{
	DocumentCommands->SaveResults();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action13Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSaveResults();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action21Execute(TObject* ASender)
{
	DocumentEntriesCommands->New();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action21Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanNew();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action221Execute(TObject* ASender)
{
	DocumentEntriesCommands->AddRegularFiles();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action221Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanAddRegularFiles();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action222Execute(TObject* ASender)
{
	DocumentEntriesCommands->AddDirectoryEntries();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action222Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanAddDirectoryEntries();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action23Execute(TObject* ASender)
{
	DocumentEntriesCommands->Cut();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action23Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanCut();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action24Execute(TObject* ASender)
{
	DocumentEntriesCommands->Copy();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action24Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanCopy();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action25Execute(TObject* ASender)
{
	DocumentEntriesCommands->Paste();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action25Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanPaste();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action26Execute(TObject* ASender)
{
	DocumentEntriesCommands->Delete();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action26Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanDelete();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action27Execute(TObject* ASender)
{
	DocumentEntriesCommands->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action27Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action28Execute(TObject* ASender)
{
	DocumentEntriesCommands->SelectFirstInGroup();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action28Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSelectFirstInGroup();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action29Execute(TObject* ASender)
{
	DocumentEntriesCommands->ReverseSelection();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action29Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanReverseSelection();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A11Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowPathField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A11Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfPath);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowPathField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A12Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowDirectoryField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A12Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfDirectory);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowDirectoryField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A13Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowBaseNameField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A13Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfBaseName);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowBaseNameField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A14Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowExtensionField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A14Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfExtension);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowExtensionField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A15Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowSizeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A15Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfSize);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowSizeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A16Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowTypeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A16Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfType);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowTypeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A17Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowCreationTimeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A17Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfCreationTime);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowCreationTimeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A18Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowLastWriteTimeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A18Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfLastWriteTime);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowLastWriteTimeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A19Execute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowLastAccessTimeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A19Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfLastAccessTime);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowLastAccessTimeField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A1AExecute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowAttributesField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A1AUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfAttributes);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowAttributesField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A1BExecute(TObject* ASender)
{
	ViewSettingsCommands->SwitchShowHashField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A1BUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewSettings->Fields.Contains(sfHash);
	LAction->Enabled = ViewSettingsCommands->CanSwitchShowHashField();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A21Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByPath();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A21Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByPath();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A22Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A22Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A23Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByName();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A23Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByName();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A24Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByBaseName();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A24Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByBaseName();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A25Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByExtension();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A25Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByExtension();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A26Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortBySize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A26Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortBySize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A27Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByType();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A27Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByType();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A28Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByCreationTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A28Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByCreationTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A29Execute(TObject* ASender)
{
	DocumentEntriesCommands->SortByLastWriteTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A29Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByLastWriteTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2AExecute(TObject* ASender)
{
	DocumentEntriesCommands->SortByLastAccessTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2AUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByLastAccessTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2BExecute(TObject* ASender)
{
	DocumentEntriesCommands->SortByAttributes();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2BUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByAttributes();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2CExecute(TObject* ASender)
{
	DocumentEntriesCommands->SortByHash();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2CUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByHash();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2DExecute(TObject* ASender)
{
	DocumentEntriesCommands->SortByPriority();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2DUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByPriority();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2EExecute(TObject* ASender)
{
	DocumentEntriesCommands->SortByGroup();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2EUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSortByGroup();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A3Execute(TObject* ASender)
{
	DocumentEntriesCommands->ReverseOrder();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A3Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanReverseOrder();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A4Execute(TObject* ASender)
{
	DocumentEntriesCommands->MoveUp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A4Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanMoveUp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A5Execute(TObject* ASender)
{
	DocumentEntriesCommands->MoveDown();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A5Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanMoveDown();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B1Execute(TObject* ASender)
{
	DocumentEntriesCommands->Open();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B1Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanOpen();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B2Execute(TObject* ASender)
{
	DocumentEntriesCommands->ExploreDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B2Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanExploreDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B3Execute(TObject* ASender)
{
	DocumentEntriesCommands->MoveToRecycleBin();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B3Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanMoveToRecycleBin();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B4Execute(TObject* ASender)
{
	DocumentEntriesCommands->ShowTotalSize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B4Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanShowTotalSize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B5Execute(TObject* ASender)
{
	DocumentEntriesCommands->ShowProperties();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2B5Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanShowProperties();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2C1Execute(TObject* ASender)
{
	DocumentEntriesCommands->SetPriorityToPrimary();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2C1Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSetPriorityToPrimary();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2C2Execute(TObject* ASender)
{
	DocumentEntriesCommands->SetPriorityToSecondary();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2C2Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanSetPriorityToSecondary();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2DExecute(TObject* ASender)
{
	DocumentEntriesCommands->RemoveAllUnique();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2DUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanRemoveAllUnique();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2EExecute(TObject* ASender)
{
	DocumentEntriesCommands->DropFiles(DroppedFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2EUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentEntriesCommands->CanDropFiles();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action311Execute(TObject* ASender)
{
	HelpCommands->OpenHelp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action311Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpCommands->CanOpenHelp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action312Execute(TObject* ASender)
{
	HelpCommands->ShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action312Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpCommands->CanShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionList1Execute(TBasicAction* AAction, bool& AHandled)
{
	AHandled = false;
	TAction* LAction = static_cast<TAction*>(AAction);
	if(LAction->OnExecute == NULL) {
		return;
	}
	TCursor LCursor = Screen->Cursor;
	Screen->Cursor = crHourGlass;
	try {
		try {
			if(LAction->Category == Action21->Category) {
				ActiveControl = ListView1;
			}
			LAction->OnExecute(LAction);
			AHandled = true;
		}
		catch(...) {
			UpdateNotifier->Invalidate();
			throw;
		}
		UpdateNotifier->Invalidate();
	}
	catch(...) {
		Screen->Cursor = LCursor;
		throw;
	}
	Screen->Cursor = LCursor;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	Action21->Execute();
	SaveSettings();
	ACanClose = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ListView1Change(TObject* ASender, TListItem* AItem, TItemChange AChange)
{
	if(AChange == ctState) {
		UpdateNotifier->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ListView1ColumnClick(TObject* ASender, TListColumn* AColumn)
{
	int LIndex = 0;
	if(ViewSettings->Fields.Contains(sfName) && LIndex++ == AColumn->Index) {
		Action2A23->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfPath) && LIndex++ == AColumn->Index) {
		Action2A21->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfDirectory) && LIndex++ == AColumn->Index) {
		Action2A22->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfBaseName) && LIndex++ == AColumn->Index) {
		Action2A24->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfExtension) && LIndex++ == AColumn->Index) {
		Action2A25->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfSize) && LIndex++ == AColumn->Index) {
		Action2A26->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfType) && LIndex++ == AColumn->Index) {
		Action2A27->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfCreationTime) && LIndex++ == AColumn->Index) {
		Action2A28->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfLastWriteTime) && LIndex++ == AColumn->Index) {
		Action2A29->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfLastAccessTime) && LIndex++ == AColumn->Index) {
		Action2A2A->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfAttributes) && LIndex++ == AColumn->Index) {
		Action2A2B->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfHash) && LIndex++ == AColumn->Index) {
		Action2A2C->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfPriority) && LIndex++ == AColumn->Index) {
		Action2A2D->Execute();
		return;
	}
	if(ViewSettings->Fields.Contains(sfGroup) && LIndex++ == AColumn->Index) {
		Action2A2E->Execute();
		return;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ListView1Data(TObject* ASender, TListItem* AItem)
{
	if(AItem->Index >= Document->Entries->Count) {
		return;
	}
	TScanEntry* LEntry = Document->Entries->Items[AItem->Index];
	if(ViewSettings->Fields.Contains(sfName)) {
		AItem->Caption = TScanEntryDescriber::DescribeByName(LEntry);
	}
	if(ViewSettings->Fields.Contains(sfPath)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByPath(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfDirectory)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByDirectory(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfBaseName)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByBaseName(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfExtension)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByExtension(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfSize)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeBySize(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfType)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByType(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfCreationTime)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByCreationTime(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfLastWriteTime)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByLastWriteTime(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfLastAccessTime)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByLastAccessTime(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfAttributes)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByAttributes(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfHash)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByHash(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfPriority)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByPriority(LEntry));
	}
	if(ViewSettings->Fields.Contains(sfGroup)) {
		AItem->SubItems->Add(TScanEntryDescriber::DescribeByGroup(LEntry));
	}
	AItem->ImageIndex = TScanEntryDescriber::DetermineImageIndex(LEntry);
	AItem->StateIndex = TScanEntryDescriber::DetermineStateIndex(LEntry);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Initialize()
{
	try {
		// Adjust the layout
		AutoSize = true;
		Panel1->Align = alClient;
		AutoSize = false;

		// Initialize classes
		TScanEntryDescriber::ImageIndex_Primary = 0;
		TScanEntryDescriber::ImageIndex_Secondary = 1;
		TScanEntryDescriber::StateIndex_NoResult = 0;
		TScanEntryDescriber::StateIndex_Unique = 1;
		TScanEntryDescriber::StateIndex_Duplicate = 2;

		// Create objects
		FSystemSettings = new TSystemSettings();
		FDocument = new TDocument();
		FDocumentCommands = new TDocumentCommands(FDocument);
		FDocumentEntriesView = new TScanEntriesView(Document->Entries, ListView1);
		FDocumentEntriesSelection = new TScanEntriesSelection(FDocument->Entries, ListView1);
		FDocumentEntriesCommands = new TScanEntriesCommands(FDocument->Entries, FDocumentEntriesSelection);
		FViewSettings = new TViewSettings(this);
		FViewSettingsView = new TViewSettingsView(FViewSettings, ListView1);
		FViewSettingsCommands = new TViewSettingsCommands(FViewSettings);
		FHelpCommands = new THelpCommands();
		FSettingsHandlers = new TSettingsHandlers();
		FSettingsHandlers->Add(FSystemSettings, "SystemSettings");
		FSettingsHandlers->Add(FDocument, "Document");
		FSettingsHandlers->Add(FDocumentCommands, "DocumentCommands");
		FSettingsHandlers->Add(FDocumentCommands, "DocumentCommands");
		FSettingsHandlers->Add(FDocumentEntriesView, "DocumentEntriesView");
		FSettingsHandlers->Add(FDocumentEntriesSelection, "DocumentEntriesSelection");
		FSettingsHandlers->Add(FDocumentEntriesCommands, "DocumentEntriesCommands");
		FSettingsHandlers->Add(FViewSettings, "ViewSettings");
		FSettingsHandlers->Add(FViewSettingsView, "ViewSettingsView");
		FSettingsHandlers->Add(FViewSettingsCommands, "ViewSettingsCommands");
		FSettingsHandlers->Add(FHelpCommands, "HelpCommands");
		FFileDropWatcher = new TFileDropWatcher(this);
		FFileDropWatcher->Enabled = true;
		FUpdateNotifier = new TUpdateNotifier();

		// Connect objects
		Application->OnIdle = ApplicationIdle;
		FDocumentEntriesCommands->OnChange = DocumentEntriesCommandsChange;
		FFileDropWatcher->OnFileDrop = FileDropWatcherFileDrop;
		FUpdateNotifier->OnUpdate = UpdateNotifierUpdate;

		// Set default values
		FViewSettings->OnFieldsChange(FViewSettings);
		UpdateAccess();

		// Load the settings
		LoadSettings();
		UpdateAccess();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Uninitialize()
{
	delete FUpdateNotifier;
	FUpdateNotifier = NULL;

	delete FFileDropWatcher;
	FFileDropWatcher = NULL;

	delete FSettingsHandlers;
	FSettingsHandlers = NULL;

	delete FHelpCommands;
	FHelpCommands = NULL;

	delete FViewSettingsCommands;
	FViewSettingsCommands = NULL;

	delete FViewSettingsView;
	FViewSettingsView = NULL;

	delete FViewSettings;
	FViewSettings = NULL;

	delete FDocumentEntriesCommands;
	FDocumentEntriesCommands = NULL;

	delete FDocumentEntriesSelection;
	FDocumentEntriesSelection = NULL;

	delete FDocumentEntriesView;
	FDocumentEntriesView = NULL;

	delete FDocumentCommands;
	FDocumentCommands = NULL;

	delete FDocument;
	FDocument = NULL;

	delete FSystemSettings;
	FSystemSettings = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::LoadSettings()
{
	SettingsHandlers->LoadSettings();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::SaveSettings()
{
	SettingsHandlers->SaveSettings();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HandleCommandLineParameters()
{
	if(ParamCount() == 0) {
		return;
	}
	TStringDynArray LFiles;
	LFiles.Length = ParamCount();
	for(int LI = 0; LI < LFiles.Length; ++LI) {
		LFiles[LI] = ParamStr(LI + 1);
	}
	HandleDroppedFiles(LFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HandleDroppedFiles(const TStringDynArray& LFiles)
{
	try {
		FDroppedFiles = LFiles;
		Action2E->Execute();
	}
	catch(...) {
		FDroppedFiles.Length = 0;
		throw;
	}
	FDroppedFiles.Length = 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateAccess()
{
	for(int LI = 0; LI < ActionList1->ActionCount; ++LI) {
		TAction* LAction = static_cast<TAction*>(ActionList1->Actions[LI]);
		if(LAction->OnUpdate != NULL) {
			LAction->OnUpdate(LAction);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateStatus()
{
	if(DocumentEntriesSelection->SelectionCount > 0) {
		Label1->Caption = AnsiString().sprintf(
			"%s items are selected",
			TCommon::FormatInteger(DocumentEntriesSelection->SelectionCount).c_str());
	}
	else {
		Label1->Caption = AnsiString().sprintf(
			"%s items",
			TCommon::FormatInteger(Document->Entries->Count).c_str());
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ApplicationIdle(TObject* ASender, bool& ADone)
{
	ADone = true;
	Application->OnIdle = NULL;
	HandleCommandLineParameters();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentEntriesCommandsChange(TObject* ASender)
{
	UpdateNotifier->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileDropWatcherFileDrop(TObject* ASender, TDroppedFiles* AFiles, bool& AHandled)
{
	::SetForegroundWindow(Handle);
	TStringDynArray LFiles;
	LFiles.Length = AFiles->Count;
	for(int LI = 0; LI < LFiles.Length; ++LI) {
		LFiles[LI] = AFiles->Files[LI];
	}
	AFiles->Finish();
	HandleDroppedFiles(LFiles);
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateNotifierUpdate(TObject* ASender)
{
	UpdateAccess();
	UpdateStatus();
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::TAppMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FSystemSettings(NULL),
	FDocument(NULL),
	FDocumentCommands(NULL),
	FDocumentEntriesView(NULL),
	FDocumentEntriesSelection(NULL),
	FDocumentEntriesCommands(NULL),
	FViewSettings(NULL),
	FViewSettingsView(NULL),
	FViewSettingsCommands(NULL),
	FHelpCommands(NULL),
	FSettingsHandlers(NULL),
	FileDropWatcher(NULL),
	UpdateNotifier(NULL),
	FDroppedFiles()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::~TAppMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------

