//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_OptionsDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppOptionsDialog* AppOptionsDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox12Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox13Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox14Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox15Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox16Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox17Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox18Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox19Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox1AClick(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox1BClick(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::CheckBox1CClick(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	ACanClose = false;
	Values = Inputs;
	ActiveControl = NULL;
	ACanClose = true;
}
//---------------------------------------------------------------------------
TScanAspects __fastcall TAppOptionsDialog::AddElement(const TScanAspects& ASet, TScanAspect AElement, bool AAdd)
{
	if(AAdd) {
		return TScanAspects(ASet) << AElement;
	}
	else {
		return TScanAspects(ASet) >> AElement;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::UpdateAccess()
{
	Button1->Enabled = !Inputs.Aspects.Empty();
}
//---------------------------------------------------------------------------
TAppOptions __fastcall TAppOptionsDialog::GetValues()
{
	return FValues;
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::SetValues(const TAppOptions& AValues)
{
	FValues = AValues;
}
//---------------------------------------------------------------------------
TAppOptions __fastcall TAppOptionsDialog::GetInputs()
{
	TAppOptions LInputs = Values;
	LInputs.Aspects = AddElement(LInputs.Aspects, saDirectory, CheckBox11->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saName, CheckBox12->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saBaseName, CheckBox13->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saExtension, CheckBox14->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saSize, CheckBox15->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saType, CheckBox16->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saCreationTime, CheckBox17->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saLastWriteTime, CheckBox18->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saLastAccessTime, CheckBox19->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saAttributes, CheckBox1A->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saHash, CheckBox1B->Checked);
	LInputs.Aspects = AddElement(LInputs.Aspects, saBinaries, CheckBox1C->Checked);
	LInputs.RememberSettings = CheckBox21->Checked;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TAppOptionsDialog::SetInputs(const TAppOptions& AInputs)
{
	CheckBox11->Checked = AInputs.Aspects.Contains(saDirectory);
	CheckBox12->Checked = AInputs.Aspects.Contains(saName);
	CheckBox13->Checked = AInputs.Aspects.Contains(saBaseName);
	CheckBox14->Checked = AInputs.Aspects.Contains(saExtension);
	CheckBox15->Checked = AInputs.Aspects.Contains(saSize);
	CheckBox16->Checked = AInputs.Aspects.Contains(saType);
	CheckBox17->Checked = AInputs.Aspects.Contains(saCreationTime);
	CheckBox18->Checked = AInputs.Aspects.Contains(saLastWriteTime);
	CheckBox19->Checked = AInputs.Aspects.Contains(saLastAccessTime);
	CheckBox1A->Checked = AInputs.Aspects.Contains(saAttributes);
	CheckBox1B->Checked = AInputs.Aspects.Contains(saHash);
	CheckBox1C->Checked = AInputs.Aspects.Contains(saBinaries);
	CheckBox21->Checked = AInputs.RememberSettings;
	UpdateAccess();
}
//---------------------------------------------------------------------------
TAppOptionsDialog* __fastcall TAppOptionsDialog::EnsureCreated()
{
	if(AppOptionsDialog == NULL) {
		AppOptionsDialog = new TAppOptionsDialog(Application);
	}
	return AppOptionsDialog;
}
//---------------------------------------------------------------------------
__fastcall TAppOptionsDialog::TAppOptionsDialog(TComponent* AOwner) :
	TForm(AOwner)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppOptionsDialog::~TAppOptionsDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TAppOptionsDialog::Execute()
{
	Inputs = Values;
	SelectFirst();
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

