//----------------------------------------------------------------------------
#ifndef App_OptionsDialogH
#define App_OptionsDialogH
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "App_Document.h"
//----------------------------------------------------------------------------
namespace App_optionsdialog {
//----------------------------------------------------------------------------
struct TAppOptions
{
	TScanAspects Aspects;
	bool RememberSettings;
};
//----------------------------------------------------------------------------
} // End namespace App_optionsdialog
using namespace App_optionsdialog;
//----------------------------------------------------------------------------
class TAppOptionsDialog : public TForm
{
__published:
	TButton* Button1;
	TButton* Button2;
	TCheckBox* CheckBox11;
	TCheckBox* CheckBox12;
	TCheckBox* CheckBox13;
	TCheckBox* CheckBox14;
	TCheckBox* CheckBox15;
	TCheckBox* CheckBox16;
	TCheckBox* CheckBox17;
	TCheckBox* CheckBox18;
	TCheckBox* CheckBox19;
	TCheckBox* CheckBox1A;
	TCheckBox* CheckBox1B;
	TCheckBox* CheckBox1C;
	TCheckBox* CheckBox21;
	TGroupBox* GroupBox1;
	void __fastcall CheckBox11Click(TObject* ASender);
	void __fastcall CheckBox12Click(TObject* ASender);
	void __fastcall CheckBox13Click(TObject* ASender);
	void __fastcall CheckBox14Click(TObject* ASender);
	void __fastcall CheckBox15Click(TObject* ASender);
	void __fastcall CheckBox16Click(TObject* ASender);
	void __fastcall CheckBox17Click(TObject* ASender);
	void __fastcall CheckBox18Click(TObject* ASender);
	void __fastcall CheckBox19Click(TObject* ASender);
	void __fastcall CheckBox1AClick(TObject* ASender);
	void __fastcall CheckBox1BClick(TObject* ASender);
	void __fastcall CheckBox1CClick(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	TAppOptions FValues;
	static TScanAspects __fastcall AddElement(const TScanAspects& ASet, TScanAspect AElement, bool AAdd);
	void __fastcall UpdateAccess();
	TAppOptions __fastcall GetValues();
	void __fastcall SetValues(const TAppOptions& AValues);
	TAppOptions __fastcall GetInputs();
	void __fastcall SetInputs(const TAppOptions& AInputs);
	__property TAppOptions Inputs = {read=GetInputs, write=SetInputs};
protected:
public:
	static TAppOptionsDialog* __fastcall EnsureCreated();
	__fastcall TAppOptionsDialog(TComponent* AOwner);
	virtual __fastcall ~TAppOptionsDialog();
	virtual bool __fastcall Execute();
	__property TAppOptions Values = {read=GetValues, write=SetValues};
};
//----------------------------------------------------------------------------
extern PACKAGE TAppOptionsDialog* AppOptionsDialog;
//----------------------------------------------------------------------------
#endif

