//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <IniFiles.hpp>
#include "App_System.h"
#include "Moa_Strings.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_system {
//---------------------------------------------------------------------------
__fastcall TSystemSettings::TSystemSettings() :
	TModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TSystemSettings::~TSystemSettings()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TSystemSettings::LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection;
	{
		SetCurrentDir(TAnsiStringUtilities::Dequote(ASettings->ReadString(
			LSection,
			"CurrentDirectory",
			TAnsiStringUtilities::Quote(GetCurrentDir(), '\"')), '\"'));
	}
}
//---------------------------------------------------------------------------
void __fastcall TSystemSettings::SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection;
	{
		ASettings->WriteString(
			LSection,
			"CurrentDirectory",
			TAnsiStringUtilities::Quote(GetCurrentDir(), '\"'));
	}
}
//---------------------------------------------------------------------------
} // End namespace App_system
//---------------------------------------------------------------------------

